"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsForeignKey = exports.IS_FOREIGN_KEY = void 0;
const class_validator_1 = require("class-validator");
exports.IS_FOREIGN_KEY = 'IsForeignKey';
const IsForeignKey = (model) => {
    return (0, class_validator_1.ValidateBy)({
        name: exports.IS_FOREIGN_KEY,
        async: true,
        validator: {
            async validate(value) {
                if (typeof value !== 'number') {
                    return false;
                }
                if (value <= 0) {
                    return false;
                }
                return !!(await model.count({
                    where: {
                        id: value,
                    },
                }));
            },
            defaultMessage() {
                return '$property not found';
            },
        },
    });
};
exports.IsForeignKey = IsForeignKey;
//# sourceMappingURL=model.js.map