"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecordType = exports.TypeBoolean = exports.ToLowerCase = exports.ToUpperCase = exports.ToFixed = void 0;
const class_transformer_1 = require("class-transformer");
const common_1 = require("@nestjs/common");
const class_validator_1 = require("class-validator");
const ToFixed = (precision = 2) => (0, class_transformer_1.Transform)(({ value }) => typeof value === 'number' ? value.toFixed(precision) : value);
exports.ToFixed = ToFixed;
const ToUpperCase = () => (0, class_transformer_1.Transform)(({ value }) => typeof value === 'string' ? value.toUpperCase() : value);
exports.ToUpperCase = ToUpperCase;
const ToLowerCase = () => (0, class_transformer_1.Transform)(({ value }) => typeof value === 'string' ? value.toLowerCase() : value);
exports.ToLowerCase = ToLowerCase;
const TypeBoolean = () => (0, class_transformer_1.Transform)(({ value }) => value && value !== 'false');
exports.TypeBoolean = TypeBoolean;
const RecordType = (valueType) => (0, common_1.applyDecorators)((0, class_transformer_1.Type)(() => valueType), (0, class_validator_1.ValidateNested)({ each: true }));
exports.RecordType = RecordType;
//# sourceMappingURL=transform.js.map