"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiPaginatedResponse = exports.PaginatedQuery = exports.Paginated = void 0;
const swagger_1 = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const decorators_1 = require("../decorators");
class Paginated {
}
__decorate([
    (0, decorators_1.ApiProperty)(),
    __metadata("design:type", Array)
], Paginated.prototype, "items", void 0);
__decorate([
    (0, decorators_1.ApiProperty)({ default: 0 }),
    __metadata("design:type", Number)
], Paginated.prototype, "page", void 0);
__decorate([
    (0, decorators_1.ApiProperty)({ default: 10 }),
    __metadata("design:type", Number)
], Paginated.prototype, "size", void 0);
__decorate([
    (0, decorators_1.ApiProperty)(),
    __metadata("design:type", Number)
], Paginated.prototype, "total", void 0);
__decorate([
    (0, decorators_1.ApiProperty)(),
    __metadata("design:type", Boolean)
], Paginated.prototype, "hasMore", void 0);
exports.Paginated = Paginated;
class PaginatedQuery {
    constructor() {
        this.page = 0;
        this.size = 10;
        this.orderBy = 'id';
    }
}
__decorate([
    (0, class_transformer_1.Type)(() => Number),
    (0, class_validator_1.Min)(0),
    (0, class_validator_1.IsInt)(),
    (0, decorators_1.ApiPropertyOptional)({ default: 0, type: Number }),
    __metadata("design:type", Object)
], PaginatedQuery.prototype, "page", void 0);
__decorate([
    (0, class_transformer_1.Type)(() => Number),
    (0, class_validator_1.Min)(1),
    (0, class_validator_1.Max)(50),
    (0, class_validator_1.IsInt)(),
    (0, decorators_1.ApiPropertyOptional)({ default: 10, type: Number }),
    __metadata("design:type", Object)
], PaginatedQuery.prototype, "size", void 0);
__decorate([
    (0, decorators_1.ApiPropertyOptional)({ default: 'id', type: String }),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.IsNotEmpty)(),
    __metadata("design:type", Object)
], PaginatedQuery.prototype, "orderBy", void 0);
exports.PaginatedQuery = PaginatedQuery;
const ApiPaginatedResponse = (options) => (0, common_1.applyDecorators)((0, swagger_1.ApiExtraModels)(Paginated, options.response), (0, swagger_1.ApiOkResponse)({
    description: options.description,
    schema: {
        allOf: [
            { $ref: (0, swagger_1.getSchemaPath)(Paginated) },
            {
                properties: {
                    items: {
                        type: 'array',
                        items: {
                            $ref: (0, swagger_1.getSchemaPath)(options.response),
                        },
                    },
                },
            },
        ],
    },
}));
exports.ApiPaginatedResponse = ApiPaginatedResponse;
//# sourceMappingURL=paginated.js.map