"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextInterceptor = exports.TRACE_ID = void 0;
const common_1 = require("@nestjs/common");
const async_context_1 = require("@nestjs-steroids/async-context");
const uuid_1 = require("uuid");
const rxjs_1 = require("rxjs");
exports.TRACE_ID = 'x-sp-trace-id';
let ContextInterceptor = class ContextInterceptor {
    constructor(ac) {
        this.ac = ac;
    }
    intercept(context, next) {
        const req = context.switchToHttp().getRequest();
        const res = context.switchToHttp().getResponse();
        const traceId = req.headers[exports.TRACE_ID] || (0, uuid_1.v4)();
        req.headers[exports.TRACE_ID] = traceId;
        res.header(exports.TRACE_ID, traceId);
        return new rxjs_1.Observable((subscriber) => {
            this.ac.registerCallback(() => {
                this.ac.set(exports.TRACE_ID, traceId);
                next.handle()
                    .pipe()
                    .subscribe({
                    complete: subscriber.complete.bind(subscriber),
                    error: subscriber.error.bind(subscriber),
                    next: subscriber.next.bind(subscriber),
                });
            });
        });
    }
};
ContextInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [async_context_1.AsyncContext])
], ContextInterceptor);
exports.ContextInterceptor = ContextInterceptor;
//# sourceMappingURL=context.js.map