"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConfig = void 0;
const convict_1 = __importDefault(require("convict"));
function createConfig(schema) {
    const config = (0, convict_1.default)(schema);
    Object.entries(config.getProperties()).forEach(([key, value]) => {
        if (!process.env[key]) {
            process.env[key] =
                typeof value === 'string' ? value : JSON.stringify(value);
        }
    });
    config.validate();
    return config;
}
exports.createConfig = createConfig;
//# sourceMappingURL=create-config.js.map