import { LoggerService } from '@nestjs/common';
import { AsyncContext } from '@nestjs-steroids/async-context';
import { RootLogger } from './root-logger';
export declare class RequestLogger implements LoggerService {
    private readonly ac;
    private readonly rootLogger;
    constructor(ac: AsyncContext<string, any>, rootLogger: RootLogger);
    private get logger();
    info(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'log' level log. equivalent to info
     */
    log(message: any, ...optionalParams: any[]): void;
    /**
     * Write an 'error' level log.
     */
    error(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'warn' level log.
     */
    warn(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'debug' level log.
     */
    debug(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'verbose' level log.
     */
    verbose(message: any, ...optionalParams: any[]): void;
}
