"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomHealthIndicatorService = void 0;
const terminus_1 = require("@nestjs/terminus");
const core_1 = require("../../core");
const common_1 = require("@nestjs/common");
let CustomHealthIndicatorService = class CustomHealthIndicatorService extends terminus_1.HealthIndicator {
    constructor(logger) {
        super();
        this.logger = logger;
    }
    async isHealthy(key, check) {
        try {
            const result = await check();
            if (!result) {
                throw new Error('Health check failed');
            }
            return this.getStatus(key, true);
        }
        catch (error) {
            this.logger.error(`Failed health check ${key}`, { error });
            throw new terminus_1.HealthCheckError(`Health check issue for ${key}`, this.getStatus(key, false));
        }
    }
};
CustomHealthIndicatorService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.RequestLogger])
], CustomHealthIndicatorService);
exports.CustomHealthIndicatorService = CustomHealthIndicatorService;
//# sourceMappingURL=health-check.js.map