import { ClassTransformOptions } from 'class-transformer';
declare type Constructor<T> = new (...args: any[]) => T;
/**
 * Convert a plain object to a class instance
 */
export declare const convertToInstance: <T>(classType: Constructor<T>, object: any, options?: ClassTransformOptions) => T;
/**
 * Convert a class instance to a plain object
 */
export declare const convertToPlain: <T>(object: T, options?: ClassTransformOptions) => Record<string, any>;
/**
 * Convert a plain object to a class instance and then serialise the class instance to json object
 */
export declare const serialize: <T>(classType: Constructor<T>, object: any, options?: ClassTransformOptions) => Record<string, any>;
export {};
